from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, File, Int, Float

Genrandomreads_V0_1_0 = CommandToolBuilder(tool="genRandomReads", base_command=["genRandomReads"], inputs=[ToolInput(tag="in_expression_levels", input_type=String(optional=True), prefix="--expressionLevels", doc=InputDocumentation(doc="[other options]")), ToolInput(tag="in_summarize_fast_a", input_type=Boolean(optional=True), prefix="--summarizeFasta", doc=InputDocumentation(doc="Only output the transcript names and lengths.")), ToolInput(tag="in_transcript_fast_a", input_type=File(optional=True), prefix="--transcriptFasta", doc=InputDocumentation(doc="The transcript database in FASTA/gz format.")), ToolInput(tag="in_total_reads", input_type=Boolean(optional=True), prefix="--totalReads", doc=InputDocumentation(doc="<int>        Total read/pairs in output.")), ToolInput(tag="in_read_len", input_type=Int(optional=True), prefix="--readLen", doc=InputDocumentation(doc="The length of the output reads. 100 by default.")), ToolInput(tag="in_rand_seed", input_type=Int(optional=True), prefix="--randSeed", doc=InputDocumentation(doc="Seed to generate random numbers. UNIXTIME is used\nas the random seed by default.")), ToolInput(tag="in_quality_ref_file", input_type=File(optional=True), prefix="--qualityRefFile", doc=InputDocumentation(doc="A textual file containing Phred+33 quanlity strings\nfor simulating sequencing errors. The quality\nstrings have to have the same length as the output\nreads. No sequencing errors are simulated when this\noption is omitted.")), ToolInput(tag="in_floor_strategy", input_type=Boolean(optional=True), prefix="--floorStrategy", doc=InputDocumentation(doc="How to deal with round-up errors. 'FLOOR': generate\nless than wanted reads; 'RANDOM': randomly assign\nmargin reads to transcripts; 'ITERATIVE': find the\nbest M value to have ~N reads.")), ToolInput(tag="in_generate_pairedend_reads", input_type=Boolean(optional=True), prefix="--pairedEnd", doc=InputDocumentation(doc="Generate paired-end reads.")), ToolInput(tag="in_insertion_len_sigma", input_type=Float(optional=True), prefix="--insertionLenSigma", doc=InputDocumentation(doc="Parameters of a truncated normal distribution for\ndeciding insertion lengths of paired-end reads.\nDefault values: mean=160, sigma=30, min=110, max=400")), ToolInput(tag="in_simple_transcript_id", input_type=Boolean(optional=True), prefix="--simpleTranscriptId", doc=InputDocumentation(doc="Truncate transcript names to the first '|' or space.")), ToolInput(tag="in_truth_in_read_names", input_type=Boolean(optional=True), prefix="--truthInReadNames", doc=InputDocumentation(doc="Encode the true locations of reads in read names.")), ToolInput(tag="in_no_actual_reads", input_type=Boolean(optional=True), prefix="--noActualReads", doc=InputDocumentation(doc="Do not actually generate reads in fastq.gz files.")), ToolInput(tag="in_var_13", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_do", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_encode", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_16", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_17", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_how", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_only", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_parameters", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_seed", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_22", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_truncate", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_two", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_best", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_26", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_int", input_type=Int(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_less", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_margin", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_strings", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_wanted", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_m", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_no", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_tpm", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_total", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_column", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_generating", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_have", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_length", input_type=Int(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_not", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_output", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_42", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_prefix", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_scanning", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_simulating", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_textual", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_than", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_to", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_49", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_actually", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_database", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_deal", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_file", input_type=File(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_54", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_of", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_read", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_sequencing", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_table", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_59", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_true", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_value", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_values_dot", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_columns", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_fast_a", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_containing", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_delimited", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_errors", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_errors_dot", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_in", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_locations", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_random", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_reads", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_transcript", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_transcripts", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_truncated", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_with", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_phred", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_are", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_by", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_names", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_normal", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_numbers_dot", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_round_up", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_tab", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_unix_time", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_and", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_distribution", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_first", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_reads_dot", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_same", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_simulated", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_one_zero_zero", input_type=Int(), position=6, doc=InputDocumentation(doc="")), ToolInput(tag="in_fast_q_do_tgz", input_type=String(), position=6, doc=InputDocumentation(doc="")), ToolInput(tag="in_is", input_type=String(), position=6, doc=InputDocumentation(doc="")), ToolInput(tag="in_when", input_type=String(), position=6, doc=InputDocumentation(doc="")), ToolInput(tag="in_as", input_type=String(), position=7, doc=InputDocumentation(doc="")), ToolInput(tag="in_used", input_type=String(), position=7, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Genrandomreads_V0_1_0().translate("wdl", allow_empty_container=True)

